Bug 974725 - (ghc-pretty-show) Review Request: ghc-pretty-show - Tools for working with derived Show instances and generic inspection of values
Review Request: ghc-pretty-show - Tools for working with derived Show instanc...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
:
Depends On: ghc-haskell-lexer js-jquery1
Blocks: 827975 1142913
  Show dependency treegraph
 
Reported: 2013-06-14 22:45 EDT by Ben Boeckel
Modified: 2015-10-08 05:10 EDT (History)
2 users (show)

See Also:
Fixed In Version: ghc-pretty-show-1.6.8.2-2.fc24
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-08 05:10:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
petersen: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
pretty-show-datadir-style.patch (1.15 KB, patch)
2015-03-05 23:40 EST, Jens Petersen
no flags Details | Diff

  None (edit)
Description Ben Boeckel 2013-06-14 22:45:52 EDT
Spec URL: http://benboeckel.net/packaging/ghc-pretty-show/ghc-pretty-show.spec
SRPM URL: http://benboeckel.net/packaging/ghc-pretty-show/ghc-pretty-show-1.5-1.fc20.src.rpm
Description:
We provide a library and an executable for working with derived 'Show'
instances. By using the library, we can parse derived 'Show' instances into a
generic data structure. The ppsh tool uses the library to produce
human-readable versions of 'Show' instances, which can be quite handy for
debugging Haskell programs. We can also render complex generic values into an
interactive Html page, for easier examination.

Fedora Account System Username: mathstuf
Comment 1 Jens Petersen 2013-09-04 01:14:14 EDT
Build fails

http://koji.fedoraproject.org/koji/taskinfo?taskID=5892410

due to unpackaged files:

   /usr/share/pretty-show-1.5/style/jquery.js
   /usr/share/pretty-show-1.5/style/pretty-show.css
   /usr/share/pretty-show-1.5/style/pretty-show.js
Comment 2 Ben Boeckel 2013-09-04 11:18:44 EDT
(In reply to Jens Petersen from comment #1)
>    /usr/share/pretty-show-1.5/style/jquery.js
>    /usr/share/pretty-show-1.5/style/pretty-show.css
>    /usr/share/pretty-show-1.5/style/pretty-show.js

I guess we'll have to see about using a system jQuery?
Comment 3 Jens Petersen 2013-09-05 21:42:04 EDT
Right good point which I forgot to mention indeed.
Comment 4 Jens Petersen 2013-09-05 22:15:54 EDT
But jquery is not packaged yet it seems: bug 857992.
So perhaps it could be waived for now.
Comment 5 Jens Petersen 2014-06-01 07:53:38 EDT
How about remove jquery from now from the package until it is packaged?

This is need for updating hledger which currently blocks ghc-7.8.
Comment 6 Jens Petersen 2014-08-28 04:54:15 EDT
ping?
Comment 7 Ben Boeckel 2015-02-24 00:28:02 EST
Spec URL: http://mathstuf.fedorapeople.org//ghc-pretty-show.spec
SRPM URL: http://mathstuf.fedorapeople.org//ghc-pretty-show-1.6.8-1.fc23.src.rpm

Scratch: ghc-pretty-show-1.6.8-1.fc23.src.rpm

Scratch build is *slightly* different; just missing the Requires on js-jquery1 (which shouldn't affect the build).
Comment 8 Jens Petersen 2015-02-28 08:52:08 EST
Thanks for the update.  The jquery approach looks good to me.

I think jquery-src.js is not needed at runtime so you could probably drop that symlink.

I know it is kind of nitpicking, it might be better to BR: js-jquery1
this would avoid some rpmlint warnings about dangling symlinks.

Unfortunately there is a License mismatch:
- the cabal file and src files says it is BSD(3)
- the License file is MIT.
I think we need to contact upstream.
Comment 9 Jens Petersen 2015-02-28 08:59:14 EST
Other than above comments here is the fedora-review output:

Package Review
==============
Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines

===== MUST items =====
C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 10 files have unknown license. Detailed output of
     licensecheck in /home/jens/pkgreview/974725-ghc-pretty-
     show/licensecheck.txt

Source is BSD but the license file is MIT.

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

Haskell:
[x]: This should never happen

===== SHOULD items =====
Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====
Generic:
[?]: Rpmlint is run on all installed packages.
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.

Installation errors
-------------------
INFO: mock.py version 1.2.7 starting (python version = 2.7.8)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled yum cache
Start: cleaning yum metadata
Finish: cleaning yum metadata
INFO: enabled ccache
Mock Version: 1.2.7
INFO: Mock Version: 1.2.7
Finish: chroot init
INFO: installing package(s): /home/jens/pkgreview/974725-ghc-pretty-show/results/ghc-pretty-show-1.6.8-1.fc21.x86_64.rpm /home/jens/pkgreview/974725-ghc-pretty-show/results/ghc-pretty-show-devel-1.6.8-1.fc21.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/yum --installroot /var/lib/mock/fedora-21-x86_64/root/ --releasever 21 install /home/jens/pkgreview/974725-ghc-pretty-show/results/ghc-pretty-show-1.6.8-1.fc21.x86_64.rpm /home/jens/pkgreview/974725-ghc-pretty-show/results/ghc-pretty-show-devel-1.6.8-1.fc21.x86_64.rpm --setopt=tsflags=nocontexts

Rpmlint
-------
Checking: ghc-pretty-show-1.6.8-1.fc21.x86_64.rpm
          ghc-pretty-show-devel-1.6.8-1.fc21.x86_64.rpm
          ghc-pretty-show-1.6.8-1.fc21.src.rpm
ghc-pretty-show.x86_64: W: spelling-error %description -l en_US ppsh -> posh, push, pp sh
ghc-pretty-show.x86_64: W: dangling-symlink /usr/share/ghc-pretty-show/jquery.js /usr/share/web-assets/jquery/1.11/jquery.min.js
ghc-pretty-show.x86_64: W: dangling-symlink /usr/share/ghc-pretty-show/jquery-src.js /usr/share/web-assets/jquery/1.11/jquery.js
ghc-pretty-show-devel.x86_64: W: no-manual-page-for-binary ppsh
ghc-pretty-show.src: W: spelling-error %description -l en_US ppsh -> posh, push, pp sh
ghc-pretty-show.src: W: strange-permission ghc-pretty-show.spec 0640L
ghc-pretty-show.src: W: strange-permission pretty-show-1.6.8.tar.gz 0640L
3 packages and 0 specfiles checked; 0 errors, 7 warnings.

Requires
--------
ghc-pretty-show-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(array-0.4.0.1-3b78425c10ff2dad7acf7e8c8ae014c3)
    ghc(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc(filepath-1.3.0.1-b12cbe18566fe1532a1fda4c85e31cbe)
    ghc(ghc-prim-0.3.0.0-d5221a8c8a269b66ab9a07bdc23317dd)
    ghc(haskell-lexer-1.0-4cd87c449a1c5d8d5a2f881ebc601d24)
    ghc(integer-gmp-0.5.0.0-2f15426f5b53fe4c6490832f9b20d8d7)
    ghc(pretty-1.1.1.0-66181c695e6a2e173ba2088cf55cc396)
    ghc(pretty-show-1.6.8-5f841b1aa33fec4469cf0b5e854b7d70)
    ghc-compiler
    ghc-devel(array-0.4.0.1-3b78425c10ff2dad7acf7e8c8ae014c3)
    ghc-devel(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc-devel(filepath-1.3.0.1-b12cbe18566fe1532a1fda4c85e31cbe)
    ghc-devel(ghc-prim-0.3.0.0-d5221a8c8a269b66ab9a07bdc23317dd)
    ghc-devel(haskell-lexer-1.0-4cd87c449a1c5d8d5a2f881ebc601d24)
    ghc-devel(pretty-1.1.1.0-66181c695e6a2e173ba2088cf55cc396)
    ghc-pretty-show(x86-64)
    libHSarray-0.4.0.1-ghc7.6.3.so()(64bit)
    libHSbase-4.6.0.1-ghc7.6.3.so()(64bit)
    libHSfilepath-1.3.0.1-ghc7.6.3.so()(64bit)
    libHSghc-prim-0.3.0.0-ghc7.6.3.so()(64bit)
    libHShaskell-lexer-1.0-ghc7.6.3.so()(64bit)
    libHSinteger-gmp-0.5.0.0-ghc7.6.3.so()(64bit)
    libHSpretty-1.1.1.0-ghc7.6.3.so()(64bit)
    libHSpretty-show-1.6.8-ghc7.6.3.so()(64bit)
    libHSrts-ghc7.6.3.so()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libffi.so.6()(64bit)
    libgmp.so.10()(64bit)
    libm.so.6()(64bit)
    librt.so.1()(64bit)
    rtld(GNU_HASH)

ghc-pretty-show (rpmlib, GLIBC filtered):
    ghc(array-0.4.0.1-3b78425c10ff2dad7acf7e8c8ae014c3)
    ghc(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc(filepath-1.3.0.1-b12cbe18566fe1532a1fda4c85e31cbe)
    ghc(ghc-prim-0.3.0.0-d5221a8c8a269b66ab9a07bdc23317dd)
    ghc(haskell-lexer-1.0-4cd87c449a1c5d8d5a2f881ebc601d24)
    ghc(pretty-1.1.1.0-66181c695e6a2e173ba2088cf55cc396)
    js-jquery1
    libHSarray-0.4.0.1-ghc7.6.3.so()(64bit)
    libHSbase-4.6.0.1-ghc7.6.3.so()(64bit)
    libHSfilepath-1.3.0.1-ghc7.6.3.so()(64bit)
    libHSghc-prim-0.3.0.0-ghc7.6.3.so()(64bit)
    libHShaskell-lexer-1.0-ghc7.6.3.so()(64bit)
    libHSinteger-gmp-0.5.0.0-ghc7.6.3.so()(64bit)
    libHSpretty-1.1.1.0-ghc7.6.3.so()(64bit)
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    rtld(GNU_HASH)

Provides
--------
ghc-pretty-show-devel:
    ghc-devel(pretty-show-1.6.8-5f841b1aa33fec4469cf0b5e854b7d70)
    ghc-pretty-show-devel
    ghc-pretty-show-devel(x86-64)
    ghc-pretty-show-static

ghc-pretty-show:
    ghc(pretty-show-1.6.8-5f841b1aa33fec4469cf0b5e854b7d70)
    ghc-pretty-show
    ghc-pretty-show(x86-64)
    libHSpretty-show-1.6.8-ghc7.6.3.so()(64bit)

Unversioned so-files
--------------------
ghc-pretty-show: /usr/lib64/ghc-7.6.3/pretty-show-1.6.8/libHSpretty-show-1.6.8-ghc7.6.3.so

Source checksums
----------------
https://hackage.haskell.org/package/pretty-show-1.6.8/pretty-show-1.6.8.tar.gz :
  CHECKSUM(SHA256) this package     : 3a0b58ab971f2e6a798380129a562804d46d401306329d8a0969addd4438cb6d
  CHECKSUM(SHA256) upstream package : 3a0b58ab971f2e6a798380129a562804d46d401306329d8a0969addd4438cb6d


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -b 974725
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Haskell, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


I opened https://github.com/yav/pretty-show/issues/12 about the license issue.
Once that is clarified I think the package can be approved.
Comment 11 Jens Petersen 2015-03-05 22:56:58 EST
Thanks for updating.

http://koji.fedoraproject.org/koji/taskinfo?taskID=9149372

1.6.8.2 was since released which corrects the license in the source files.
So I recommend upgrading directly to it after importing
(you can try "cblrpm update":).

License issue mentioned earlier has been clarified and fixed to MIT.

Looks good to me now.

One last suggestion: replace "rm -rf" with just "rm".

APPROVED.
Comment 12 Jens Petersen 2015-03-05 23:38:16 EST
I tried installing the package into rawhide and f21 to check also
on the symlinks warning - seems to be a rpmlint bug afaict.

However while checking that I noticed that the datadir packaging
is not quite correct: in fact there is still a copy of jquery under style/...

Let me attach a patch with a suggested fix to make it clearer.
Comment 13 Jens Petersen 2015-03-05 23:40:54 EST
Created attachment 998655 [details]
pretty-show-datadir-style.patch

Please apply this patch to fix the jquery location when importing.

Note that datadir is assumed to be /usr/share/pretty-show-version/
by the library using the Cabal config.
Comment 14 Jens Petersen 2015-03-06 00:35:11 EST
Oh two more points occurred to me:

- BR for jquery is actually redundant I think

- It might be more stable to change the symlinks to jquery/1
  rather than jquery/1.11?  (I dunno how often jquery1 gets
  updated, but this would avoid needing a rebuild for 1.12, etc say.)
Comment 16 Jens Petersen 2015-09-03 22:32:54 EDT
You forgot to upload the new spec file, which confuses fedora-review.

You have an extra copy of LICENSE in %doc: please drop that when importing.
For that you need to add "rm %{buildroot}%{ghc_pkgdocdir}/LICENSE"
unfortunately. (Ideally --licensedir support should be added to Cabal.)

Otherwise it looks good to me now.

APPROVED
Comment 17 Ben Boeckel 2015-09-07 23:23:10 EDT
Hrm. The upload is done by a script. I'll have to look into why it is acting weird.
Comment 18 Ben Boeckel 2015-09-08 23:24:23 EDT
Hmm. It seems I have uploaded the new spec file? The srpm should be there as well?
Comment 19 Jens Petersen 2015-09-14 04:52:56 EDT
http://benboeckel.net/packaging/ghc-pretty-show/ghc-pretty-show.spec is version 1.5!

Anyway please go ahead with the SCM request... :)
Comment 20 Ben Boeckel 2015-09-14 08:45:19 EDT
Oops. I wonder if the glob messed from the upload script or something?

New Package SCM Request
=======================
Package Name: ghc-pretty-show
Short Description: Tools for working with derived Show instances and generic inspection of values
Upstream URL: https://hackage.haskell.org/package/pretty-show
Owners: mathstuf
Branches: devel
InitialCC: haskell-devel
Comment 21 Jon Ciesla 2015-09-14 11:12:45 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.